;-----------------------------------------------------------------------------
;* int01a.asm   Interrupt Example          last Update: 25.8.2012
;* Version: 0.0
;* Prozessor: Atmega8
;* Circuit: see int01.cc
;* Autor: Rolf Pfister
;* Copyright: Freeware
;*
;-----------------------------------------------------------------------------
	.include "m8def.inc" 	; Definitions for ATmega8
; Reset and Interruptvectors	;VNr. Comments
begin:	rjmp	main		; 1   Power On Reset
	rjmp	int0_vect	; 2   Int0-Interrupt
	rjmp	int1_vect	; 3   Int1-Interrupt
	reti			; 4   TC2 Compare Match
	reti			; 5   TC2 Overflow
	reti			; 6   TC1 Capture
	reti			; 7   TC1 Compare Match A
	reti			; 8   TC1 Compare Match B
	reti			; 9   TC1 Overflow
	reti			; 10  TC0 Overflow
	reti			; 11  SPI, STC = Serial Transfer Complete
	reti			; 12  UART Rx Complete
	reti			; 13  UART Data Register Empty
	reti			; 14  UART Tx Complete
	reti			; 15  ADC Conversion Complete
	reti			; 16  EEPROM ready
	reti			; 17  Analog Comperator
	reti			; 18  TWI (I2C) Serial Interface
	reti			; 19  Store Program Memory ready
;-----------------------------------------------------------------------------
	.def button1 = r18
	.def button2 = r19
int0_vect:
	ldi button1, 1
	reti
int1_vect:
	ldi button2, 1
	reti

init_interrupts:
	ldi r16, (1<<ISC00) | (1<<ISC10) ;any logical change on INT0 and INT1 generates an interrupt
	out MCUCR, r16
	ldi r16, (1<<INT1) | (1<<INT0) ;turn on interrupts for INT0 and INT1
	out GICR, r16
	ret
	
;-----------------------------------------------------------------------------
; Start, Power On, Reset
main:	ldi r16, RAMEND&0xFF
        out SPL, r16  	     ; Init Stackpointer L
	ldi r16, (RAMEND>>8)
        out SPH, r16  	     ; Init Stackpointer H

;; Init-Code
	ldi r16, 0x07		;3 LEDs as output
        out DDRB, r16
        ldi r16, 0
        out PORTB, r16
	ldi r16, 0x0C
	out PORTD, r16		;set pullup resistors for PD2 and PD3
	ldi r24, 0
	ldi r25, 0		;r25:r24 = counter = 0
	rcall init_interrupts
	sei			;turn on interrupts
;-----------------------------------------------------------------------------
mainloop:
	tst button1
	breq L1			;branch if button1 equal 0
	sbi PORTB, 0		;set bit 0 in PORTB, LED1 on
	cbi PORTB, 1		;clear bit 1 in PORTB, LED2 off
	ldi button1, 0
L1:	
	tst button2
	breq L2			;branch if button2 equal 0
	cbi PORTB, 0		;clear bit 0 in PORTB, LED1 off
	sbi PORTB, 1		;set bit 1 in PORTB, LED2 on
	ldi button2, 0
L2:	
	adiw r24, 1		;counter++
	brne mainloop
	in r16, PORTB
	ldi r17, 4
	eor r16, r17
	out PORTB, r16		;let LED3 blinking
	rjmp mainloop
